<template>
  <crud-data-table-delete
    v-model="dialog"
    :entity-being-deleted="$t('category')"
    :item-being-deleted="categoryBeingDeleted"
    :loading="isLoading"
    @onAgree="onAgree"
    @onDisagree="onDisagree"
  />
</template>

<script>
  export default {
    name: 'DeleteCategoryDialog',
    data () {
      return {
        dialog: false,
        isLoading: false,
        categoryBeingDeleted: {},
      }
    },
    created () {
      this.$emit('onDeleteCategory', this.onDeleteCategory)
    },
    methods: {
      onDeleteCategory (category) {
        this.categoryBeingDeleted = category
        this.dialog = true
      },
      onAgree () {
        this.isLoading = true
        this.$store.dispatch('categories/deleteCategory', {
          ID: this.categoryBeingDeleted.id,
        })
          .then(() => {
            this.$store.dispatch('toast/setOptions', {
              variant: 'success',
              text: this.$t('deleteSuccess'),
            })
          })
          .catch(() => {
            this.$store.dispatch('toast/setOptions', {
              variant: 'error',
              text: this.$t('deleteError'),
            })
          })
          .finally(() => {
            this.dialog = false
            this.isLoading = false
          })
      },
      onDisagree () {
        this.dialog = false
      },
    },
    i18n: {
      messages: {
        'pt-BR': {
          category: 'Categoria',
          deleteSuccess: 'Categoria excluída com sucesso!',
          deleteError: 'Ops... Algo deu errado ao tentar excluir a categoria. Por favor, tente novamente.',
        },
        'en-US': {
          category: 'Category',
          deleteSuccess: 'Category successfully deleted!',
          deleteError: 'Oops... Something went wrong while trying to delete the category. Please try again.',
        },
      },
    },
  }
</script>
